searchNodes=[{"doc":"Tools for operating on versioned records.","ref":"Versioned.html","title":"Versioned","type":"module"},{"doc":"Given a versioned struct , populate its :version_id field.","ref":"Versioned.html#add_version_id/1","title":"Versioned.add_version_id/1","type":"function"},{"doc":"Same as delete/2 but returns the struct or raises if the changeset is invalid.","ref":"Versioned.html#delete!/2","title":"Versioned.delete!/2","type":"function"},{"doc":"Deletes a struct using its primary key and adds a deleted version.","ref":"Versioned.html#delete/2","title":"Versioned.delete/2","type":"function"},{"doc":"Proxy function for the given repo module's get/3 .","ref":"Versioned.html#get/3","title":"Versioned.get/3","type":"function"},{"doc":"Proxy function for the given repo module's get_by/3 .","ref":"Versioned.html#get_by/3","title":"Versioned.get_by/3","type":"function"},{"doc":"Get the most recent version of module with the given entity_id . Options can include anything used by the repo's get/3 .","ref":"Versioned.html#get_last/3","title":"Versioned.get_last/3","type":"function"},{"doc":"List all versions for a schema module, newest first. History will be found based on a module name and id or pass in a struct. Options can include anything used by the repo's all/2 and history_query/3 .","ref":"Versioned.html#history/3","title":"Versioned.history/3","type":"function"},{"doc":"Get the query to fetch all the versions for a schema, newest first. Options :limit - Max number of records to return. Default: return all records.","ref":"Versioned.html#history_query/3","title":"Versioned.history_query/3","type":"function"},{"doc":"Same as insert/2 but returns the struct or raises if the changeset is invalid.","ref":"Versioned.html#insert!/2","title":"Versioned.insert!/2","type":"function"},{"doc":"Inserts a versioned struct defined via Ecto.Schema or a changeset.","ref":"Versioned.html#insert/2","title":"Versioned.insert/2","type":"function"},{"doc":"Get the timestamp for the very first version of this entity.","ref":"Versioned.html#inserted_at/1","title":"Versioned.inserted_at/1","type":"function"},{"doc":"Proxy function for the given repo module's one/3 .","ref":"Versioned.html#one/2","title":"Versioned.one/2","type":"function"},{"doc":"Preload version associations. Example iex&gt; pv = Repo . get ( Person.Version , &quot;7f85b58b-ef57-4288-ade0-ff47f0ceb116&quot; ) iex&gt; Versioned . preload ( pv , :fancy_hobby_versions ) % Person.Version { id : &quot;7f85b58b-ef57-4288-ade0-ff47f0ceb116&quot; , fancy_hobby_versions : [ %{ id : &quot;a2a911fb-e2a6-459c-93e2-616be0fa1a45&quot; , name : &quot;Jenga&quot; } ] }","ref":"Versioned.html#preload/2","title":"Versioned.preload/2","type":"function"},{"doc":"Same as update/2 but returns the struct or raises if the changeset is invalid.","ref":"Versioned.html#update!/2","title":"Versioned.update!/2","type":"function"},{"doc":"Updates a versioned changeset using its primary key.","ref":"Versioned.html#update/2","title":"Versioned.update/2","type":"function"},{"doc":"Get the version module from the subject module.","ref":"Versioned.html#version_mod/1","title":"Versioned.version_mod/1","type":"function"},{"doc":"True if the given module or struct is a version.","ref":"Versioned.html#version?/1","title":"Versioned.version?/1","type":"function"},{"doc":"True if the Ecto.Schema module is versioned. This means there is a corresponding Ecto.Schema module with an extra &quot;.Version&quot; on the end.","ref":"Versioned.html#versioned?/1","title":"Versioned.versioned?/1","type":"function"},{"doc":"Build the query to populate the :version_id virtual field on a versioned entity. query may be any existing base query for the entity which is versioned. mod , if defined, should be the entity module name itself. If not defined, query must be this module name and not any type of query.","ref":"Versioned.html#with_version_id/2","title":"Versioned.with_version_id/2","type":"function"},{"doc":"Helpers for Absinthe schemas.","ref":"Versioned.Absinthe.html","title":"Versioned.Absinthe","type":"module"},{"doc":"","ref":"Versioned.Absinthe.html#version_fields/1","title":"Versioned.Absinthe.version_fields/1","type":"macro"},{"doc":"Convert a list of ast lines into ast lines to be used for the version object.","ref":"Versioned.Absinthe.html#version_lines/1","title":"Versioned.Absinthe.version_lines/1","type":"macro"},{"doc":"Declare an object, versioned compliment, and interface, based off name name . The caller should use Absinthe.Schema.Notation as here we return code which invokes its object macro. Both objects belong to an interface which encompasses the common fields. All common fields (except :id and :inserted_at ) are included under an interface, named by the entity name and suffixed _base . The generated object will have the following fields: :id - ID of the record. :version_id - ID of the most recent record's version. :inserted_at - Timestamp when the record was created. :updated_at - Timestamp when the record was last updated. Additionally, all fields declared in the block. The generated version object will have the following fields: :id - ID of the version record. :foo_id - If the entity was :foo , then this would be the id of the main record for which this version is based. :is_deleted - Boolean indicating if the record was deleted as of this version. :inserted_at - Timestamp when the version record was created. Additionally, all fields declared in the block. Declaring Fields for Version Object Only In order for a field to appear only in the version object, use the :version_fields option in the (optional) keyword list before the do block: versioned_object :car , version_fields : [ person_versions : non_null ( list_of ( non_null ( :person_version ) ) ) ] do ... end","ref":"Versioned.Absinthe.html#versioned_object/3","title":"Versioned.Absinthe.versioned_object/3","type":"macro"},{"doc":"Tools shared between modules. (For internal use.)","ref":"Versioned.Helpers.html","title":"Versioned.Helpers","type":"module"},{"doc":"Create a version_mod struct to insert from a new instance of the record. Options :deleted - If true , records will marked as deleted. :change - For updates, an Ecto.Changeset.t/0 should be provided to inform which records were inserted vs updated vs deleted.","ref":"Versioned.Helpers.html#build_version/2","title":"Versioned.Helpers.build_version/2","type":"function"},{"doc":"Recursively crawl changeset and compile a list of version structs with is_deleted set to true. The changeset to operate on is passed in either as the first parameter or under the :change key in opts .","ref":"Versioned.Helpers.html#deleted_versions/2","title":"Versioned.Helpers.deleted_versions/2","type":"function"},{"doc":"Wrap a line of AST in a block if it isn't already wrapped.","ref":"Versioned.Helpers.html#normalize_block/1","title":"Versioned.Helpers.normalize_block/1","type":"function"},{"doc":"Allows creating tables for versioned schemas. Example defmodule MyApp.Repo.Migrations.CreateCar do use Versioned.Migration def change do create_versioned_table ( :cars ) do add :name , :string end end end","ref":"Versioned.Migration.html","title":"Versioned.Migration","type":"module"},{"doc":"Add a new column to both the main table and the versions table. Any foreign key constraint via references/2 will be stripped for the versions table.","ref":"Versioned.Migration.html#add_versioned_column/4","title":"Versioned.Migration.add_versioned_column/4","type":"macro"},{"doc":"Create a table whose data is versioned by also creating a secondary table with the immutable, append-only history.","ref":"Versioned.Migration.html#create_versioned_table/3","title":"Versioned.Migration.create_versioned_table/3","type":"macro"},{"doc":"Modify orig_field column in table table_name and its versioned counterpart. See Ecto.Migration.modify/3 . Example defmodule MyApp.Repo.Migrations.RenameFooToBar do use Versioned.Migration def change do modify_versioned_column ( &quot;my_table&quot; , :foo , :text , null : true ) end end","ref":"Versioned.Migration.html#modify_versioned_column/4","title":"Versioned.Migration.modify_versioned_column/4","type":"macro"},{"doc":"Removes a column from a table and its versioned counterpart. See Ecto.Migration.remove/1 . Example defmodule MyApp.Repo.Migrations.RemoveFooToBar do use Versioned.Migration def change do remove_versioned_column ( &quot;my_table&quot; , :foo ) end end","ref":"Versioned.Migration.html#remove_versioned_column/2","title":"Versioned.Migration.remove_versioned_column/2","type":"macro"},{"doc":"Rename orig_field column in table table_name to a new name. See Ecto.Migration.rename/3 . Note that this is indeed changing the field names as well in the complimenting and generally immutable &quot;versions&quot; table. Example defmodule MyApp.Repo.Migrations.RenameFooToBar do use Versioned.Migration def change do rename_versioned_column ( &quot;my_table&quot; , :foo , to : :bar ) end end","ref":"Versioned.Migration.html#rename_versioned_column/3","title":"Versioned.Migration.rename_versioned_column/3","type":"macro"},{"doc":"Renames a table table and its versioned counterpart. See Ecto.Migration.rename/2 . Other Considerations If the table is cars , then cars_versions has a car_id field. If the table is being renamed to automobiles , then after using this macro, you'll want to also do something like the following in order to rename the car_id field in the versions table to automobile_id . rename table ( &quot;automobiles_versions&quot; ) , :car_id , to : :automobile_id If your table has additional foreign key constraints such as those set up with Ecto.Migration.references/2 , you'll want to move those over, too, with something like this. The versions table won't have any such constraints. execute ( &quot;ALTER TABLE automobiles RENAME CONSTRAINT cars_garage_id_fkey TO automobiles_garage_id_fkey;&quot; , &quot;ALTER TABLE automobiles RENAME CONSTRAINT automobiles_garage_id_fkey TO cars_garage_id_fkey;&quot; ) Example defmodule MyApp.Repo.Migrations.RenameCarsToAutomobiles do use Versioned.Migration def change do rename_versioned_table ( &quot;cars&quot; , &quot;automobiles&quot; ) rename table ( &quot;automobiles_versions&quot; ) , :car_id , to : :automobile_id end end","ref":"Versioned.Migration.html#rename_versioned_table/2","title":"Versioned.Migration.rename_versioned_table/2","type":"macro"},{"doc":"","ref":"Versioned.Migration.html#versions_type/1","title":"Versioned.Migration.versions_type/1","type":"function"},{"doc":"Tools for operating on versioned records.","ref":"Versioned.Multi.html","title":"Versioned.Multi","type":"module"},{"doc":"To be invoked after Repo.transaction/1 . If successful, the id of &quot;_version&quot; will be attached to the :version_id field of of the returned record.","ref":"Versioned.Multi.html#add_version_to_record/2","title":"Versioned.Multi.add_version_to_record/2","type":"function"},{"doc":"Returns an Ecto.Multi with all steps necessary to delete a versioned record. An Ecto.Multi is returned which first updates the record itself, inserts a new version into the versions table and finally deletes associations as needed. If name is &quot;puppy&quot; , the returned parts will be: :puppy - The updated record itself. &quot;puppy_version&quot; - The newly inserted version record (is_deleted=TRUE).","ref":"Versioned.Multi.html#delete/4","title":"Versioned.Multi.delete/4","type":"function"},{"doc":"Returns an Ecto.Multi with all steps necessary to insert a versioned record. If name is :puppy , the returned parts will be: :puppy - The inserted record itself. &quot;puppy_version&quot; - The inserted version record.","ref":"Versioned.Multi.html#insert/4","title":"Versioned.Multi.insert/4","type":"function"},{"doc":"See Ecto.Multi.new/0 .","ref":"Versioned.Multi.html#new/0","title":"Versioned.Multi.new/0","type":"function"},{"doc":"Returns an Ecto.Multi with all steps necessary to update a versioned record. An Ecto.Multi is returned which first updates the record itself, inserts a new version into the versions table and finally deletes associations as needed. If name is &quot;puppy&quot; , the returned parts will be: :puppy - The updated record itself. &quot;puppy_version&quot; - The newly inserted version record. &quot;puppy_deletes&quot; - List of association version records which were deleted. &quot;puppy_full&quot; - Internal use only. A tuple with the updated record and opts including the changeset.","ref":"Versioned.Multi.html#update/4","title":"Versioned.Multi.update/4","type":"function"},{"doc":"Enhances Ecto.Schema modules to track a full history of changes. The versioned_schema macro works just like schema in Ecto.Schema but it also builds an OriginalModule.Version schema module as well to represent a version at a particular point in time. In addition to options allowed by Ecto.Schema , new ones are also allowed. Additional belongs_to Options :versioned - If true , the version schema will include an extra field of the same name but with _version appended. The parent record which existed when this version was created can be loaded into this field via Versioned.preload/2 . Example: versioned_schema &quot;people&quot; do belongs_to :car , Car , type : :binary_id , versioned : true end Additional has_many Options :versioned - If true , the version schema will include an extra field of the same name but with _version appended. If defined as another truthy atom, then that field name will be used instead. The child records which existed when this version was created can be loaded into this field via Versioned.preload/2 . Example: versioned_schema &quot;cars&quot; do has_many :people , Person , on_replace : :delete , versioned : :person_versions end I already have an integer primary key. While Versioned generally operates with binary_ids, it is possible to adopt it for an existing table which uses integers. First, you'll need to create a migration to create the versions table. Then, define your own @primary_key attribute. Versioned will preserve it. (Note that the versions table must still use UUIDs.) @primary_key { :id , :id , autogenerate : true } versioned_schema &quot;cars&quot; do ... end Add Code to the Version Module To add additional functions to the version module, auto-generated by versioned_schema/2 , add a version block somewhere before versioned_schema . version do def hello_world , do : :ok end versioned_schema &quot;cars&quot; do ... end Example defmodule MyApp.Car do use Versioned.Schema versioned_schema &quot;cars&quot; do field :name , :string has_many :people , MyApp.Person , versioned : true end end","ref":"Versioned.Schema.html","title":"Versioned.Schema","type":"module"},{"doc":"Register some code to be injected into the Version module.","ref":"Versioned.Schema.html#version/1","title":"Versioned.Schema.version/1","type":"macro"},{"doc":"","ref":"Versioned.Schema.html#version_before_compile/1","title":"Versioned.Schema.version_before_compile/1","type":"macro"},{"doc":"Convert a list of ast lines from the main schema into ast lines to be used for the version schema.","ref":"Versioned.Schema.html#version_lines/1","title":"Versioned.Schema.version_lines/1","type":"macro"},{"doc":"Create a versioned schema.","ref":"Versioned.Schema.html#versioned_schema/2","title":"Versioned.Schema.versioned_schema/2","type":"macro"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"","ref":"changelog.html#0-4-0","title":"Changelog - [0.4.0]","type":"extras"},{"doc":"Versioned.Multi functions now return the main record with the very same name given. (Previously, it was coerced into a string and appended with &quot;_record&quot;.) Versioned.Multi functions now accept functions to more closely match the Ecto.Multi API.","ref":"changelog.html#changed","title":"Changelog - Changed","type":"extras"},{"doc":"","ref":"changelog.html#0-3-3-2022-01-20","title":"Changelog - [0.3.3] - 2022-01-20","type":"extras"},{"doc":"Versioned.insert!/2 , Versioned.update!/2 and Versioned.delete!/2 for better mimicking Ecto.Repo .","ref":"changelog.html#added","title":"Changelog - Added","type":"extras"},{"doc":"","ref":"changelog.html#0-3-2-2021-12-09","title":"Changelog - [0.3.2] - 2021-12-09","type":"extras"},{"doc":"Fix for add_versioned_column/4 . Better clarity and bugfixes around the fact that there should be no foreign key constraints in the versions tables. If you are using this library in production, you should be aware that your versions tables may have foreign key constraints where they were not intended. If you have any foreign keys in your versions tables, use something like the following for each in a new change/0 migration function to get back on track. execute ( &quot;ALTER TABLE cars_versions DROP CONSTRAINT cars_versions_garage_id_fkey;&quot; , &quot;ALTER TABLE cars_versions ADD CONSTRAINT cars_versions_garage_id_fkey FOREIGN KEY (garage_id) REFERENCES garages(id);&quot; )","ref":"changelog.html#changed","title":"Changelog - Changed","type":"extras"},{"doc":"","ref":"changelog.html#0-3-1-2021-12-08","title":"Changelog - [0.3.1] - 2021-12-08","type":"extras"},{"doc":"Versioned.Migration.rename_versioned_table","ref":"changelog.html#added","title":"Changelog - Added","type":"extras"},{"doc":"Fixed Versioned.Migration.remove_versioned_column .","ref":"changelog.html#changed","title":"Changelog - Changed","type":"extras"},{"doc":"","ref":"changelog.html#0-3-0-2021-11-29","title":"Changelog - [0.3.0] - 2021-11-29","type":"extras"},{"doc":"Versioned.get_by/2 Versioned.one/2 Versioned.Multi now exposes operations for Ecto.Multi transactions. Ecto.Schema.version macro for writing code to the auto-generated &quot;.Version&quot; module.","ref":"changelog.html#added","title":"Changelog - Added","type":"extras"},{"doc":"Versioned.get/2 is now a direct proxy for your MyApp.Repo.get/2 .","ref":"changelog.html#changed","title":"Changelog - Changed","type":"extras"},{"doc":"","ref":"changelog.html#0-2-1-2021-09-04","title":"Changelog - [0.2.1] - 2021-09-04","type":"extras"},{"doc":"Versioned.add_version_id/1 fills the :version_id of a versioned struct. :version_fields option for versioned_object/3 macro. Versioned.Migration.modify_versioned_column/4 . Versioned.Migration.rename_versioned_column/3 . Versioned.Migration.remove_versioned_column/2 .","ref":"changelog.html#added","title":"Changelog - Added","type":"extras"},{"doc":"Added Base schema now has has_many :versions Version schema swapped its simple :entity_id field for a belongs_to which achieves the same, plus adding the :entity field and the ability to query with the assoc. Added Versioned.Absinthe.versioned_object/2 absinthe helper which creates the base object and the versioned one at the same time. Added Versioned.get_last/3 which fetches the last version record in a history. Changed Versioned.with_versions became Versioned.with_version_id . I originally named the function incorrectly ;)","ref":"changelog.html#0-2-0-2021-07-26","title":"Changelog - [0.2.0] - 2021-07-26","type":"extras"},{"doc":"Added Initial release","ref":"changelog.html#0-1-0-2021-07-15","title":"Changelog - [0.1.0] - 2021-07-15","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Instinct Science Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Note: Elixir 1.13 introduced a regression which will cause warnings for each of your versioned schema modules. It has been resolved in 1.13.2. Versioned is a tool for enhancing Ecto.Schema modules to keep a full history of changes. The underlying method is to create a corresponding &quot;versions&quot; table for each schema (with all the same columns) where each record indicates a create, update, or delete event. When a record is deleted, the versions table entry has the record in its final state, and the special is_deleted field will be set to true. Importantly, the versions table features NO foreign key constraints. This means a couple of things. First, the auto-generated foreign key column in the versions table doesn't depend on the record in the main table, which may be deleted. Secondly, any field you define with Ecto.Migration.references/2 will only have the constraint for the main table. Here again, the referenced records can be deleted without worry of version records. Records in the main table are mutable and operated on as normal, including deletes where the record is truly deleted. Versioned provides helpers for migrations and schemas. The Versioned module has Versioned.insert/2 , Versioned.update/2 and Versioned.delete/2 which should be used in place of your application's Repo for versioned tables. Finally, Versioned.history/3 can be used to retrieve a list of entity versions, newest first.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"def deps do [ { :versioned , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"defmodule MyApp.Repo.Migrations.CreateCar do use Versioned.Migration def change do # Creates 2 tables: # - &quot;cars&quot; with columns id, name, inserted_at and updated_at # - &quot;cars_versions&quot; with columns id, name, car_id and inserted_at create_versioned_table ( :cars ) do add :name , :string end end end defmodule MyApp.Car do use Versioned.Schema versioned_schema &quot;cars&quot; do field :name , :string end end defmodule MyApp do alias MyApp.Car def do_some_stuff do { :ok , %{ id : car_id } = car } = Versioned . insert ( % Car { name : &quot;Toad&quot; } ) { :ok , car } = car |&gt; Ecto.Changeset . change ( ) |&gt; Ecto.Changeset . cast ( %{ name : &quot;Magnificent&quot; } , [ :name ] ) |&gt; Versioned . update ( ) { :ok , _car } = Versioned . delete ( car ) # The record is deleted. nil = MyApp.Repo . get ( Car , car_id ) # `Versioned.history/2` still returns all changes, newest first. [ % Car.Version { car_id : ^ car_id , name : &quot;Magnificent&quot; , is_deleted : true } , % Car.Version { car_id : ^ car_id , name : &quot;Magnificent&quot; , is_deleted : false } , % Car.Version { car_id : ^ car_id , name : &quot;Toad&quot; , is_deleted : false } ] = Versioned . history ( Car , car_id ) end end","ref":"readme.html#example","title":"Overview - Example","type":"extras"},{"doc":"Also of note is the library's ability to properly manage version records when inserting, updating or deleting groups of records via has_many relationships with Ecto.Changeset.cast_assoc/3 . Note that creating or updating a single child record in the params for a belongs_to connection is not currently supported. In fact, there are probably other potentially useful features and pieces which have not yet been explored.","ref":"readme.html#managing-groups-of-records-together","title":"Overview - Managing Groups of Records Together","type":"extras"},{"doc":"Migration Helper: Add Column on a Versioned Table Later, manage versioned tables with these convenience macros which appropriately work on the field in both tables. defmodule MyApp.Repo.Migrations.DoCarChangeThings do use Versioned.Migration def change do add_versioned_column ( &quot;cars&quot; , :color , :string ) rename_versioned_column ( &quot;cars&quot; , :color , to : :color_info ) modify_versioned_column ( &quot;cars&quot; , :color_info , :text , null : false ) remove_versioned_column ( &quot;cars&quot; , :color_info ) rename_versioned_table ( &quot;cars&quot; , &quot;automobiles&quot; ) end end Absinthe Helper: Create a Version Object While versioned does not depend on Absinthe, it does provide a shortcut for creating an absinthe &quot;version&quot; object, wrapping one of your entities. In the following example, :car_version would have the following fields: :id - primary key of the version record :is_deleted - boolean indicating if the record was deleted as of this version :inserted_at - UTC timestamp, indicating when the version was created :car - The car as it was in this version defmodule MyApp.Schema.Types.User do use Absinthe.Schema.Notation import Versioned.Absinthe object :car do field :id , :id field :name , :string end version_object :car_version , :car end","ref":"readme.html#extras","title":"Overview - Extras","type":"extras"},{"doc":"Copyright (c) 2021 Instinct Science This library is licensed under the MIT License .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]